package com.acme;

import com.sun.grizzly.tcp.Adapter;
import com.sun.grizzly.tcp.Request;
import com.sun.grizzly.tcp.Response;
import com.sun.grizzly.util.buf.ByteChunk;
import java.io.IOException;
import java.util.concurrent.SynchronousQueue;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

/**
 *
 */
public class MyAdapter implements Adapter
{
    private ThreadPoolExecutor		executor;
    private ByteChunk               bc;
    private boolean                 suspendMode;

    public MyAdapter( boolean suspendMode )
        throws IOException
    {
        executor = new ThreadPoolExecutor( 0, 500, 5*60, TimeUnit.SECONDS, new SynchronousQueue<Runnable>() );
        bc = new ByteChunk();
        bc.append( "pong".getBytes(), 0, 4 );
        this.suspendMode = suspendMode;
    }

    @Override
	public void service( Request request, Response response ) throws Exception
    {
        if( suspendMode )
        {
            if( !response.isSuspended() )
            {
                response.suspend();
            }
            else
            {
                System.out.println( "Response already suspended, normal ??");
            }
            executor.execute( new MyExecutor(request,response,bc) );
        }
        else
        {
            response.setStatus( 200 );
            response.setMessage( "Sounds good" );
            response.doWrite( bc );
            response.flushHeaders();
            response.flush();
        }
    }

    @Override
	public void afterService( Request request, Response response ) throws Exception
    {
        request.recycle();
        response.recycle();
    }
}
