package com.acme;

import com.sun.grizzly.tcp.Request;
import com.sun.grizzly.tcp.Response;
import com.sun.grizzly.util.buf.ByteChunk;

/**
 *
 * @author dGay
 */
public class MyExecutor implements Runnable
{
    Request     req;
    Response    res;
    ByteChunk   bc;

    public MyExecutor( Request req, Response res, ByteChunk bc )
    {
        this.req = req;
        this.res = res;
        this.bc = bc;
    }

    @Override
    public void run()
    {
        try
        {
            // Thread.sleep( 5 );
            res.setStatus( 200 );
            res.setMessage( "Sounds good" );
            res.doWrite( bc );
            res.finish();
            
        }
        catch( Exception ex )
        {
            System.out.println( "\n\tException while writing response !" );
            ex.printStackTrace( System.out );
            System.out.println();
        }
        finally
        {
            try
            {
                if( res.isSuspended() )
                {
                    res.resume();
                }
                else
                {
                    System.out.println( "Should be suspended !" );
                }
            }
            catch( Exception ex )
            {
                System.out.println( "\n\tException while resuming !" );
                ex.printStackTrace( System.out );
                System.out.println();
            }
        }
    }
}
