package com.acme.test;

import java.util.concurrent.atomic.AtomicInteger;
import org.apache.commons.httpclient.DefaultHttpMethodRetryHandler;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpConnectionManager;
import org.apache.commons.httpclient.HttpMethod;
import org.apache.commons.httpclient.methods.GetMethod;
import org.apache.commons.httpclient.params.HttpMethodParams;

/**
 *
 */
public  class       Caller
        implements  Runnable
{
    private String          url;
    private int             count;
    private AtomicInteger   succes;
    private HttpClient      client;

    public Caller( String url, int count, AtomicInteger succes, HttpConnectionManager cm )
    {
        this.url = url;
        this.count = count;
        this.succes = succes;
        client = new HttpClient( cm );
    }

    @Override
    public void run()
    {
        int code;
        int i;
        HttpMethod method = null;

        for( i=0; i<count; i++ )
        {
            try
            {
                method = new GetMethod( url );
                method.getParams().setParameter(HttpMethodParams.RETRY_HANDLER, new DefaultHttpMethodRetryHandler(0, false));
                code = client.executeMethod( method );
                if( code == 200 )
                {
                    succes.getAndIncrement();
                }
                else
                {
                    System.out.println( "Error ("+i+") returning :"+code );
                }
            }
            catch( Exception ex )
            {
                System.out.println( "BAD :"+ex.getMessage() );
            }
            finally
            {
                method.releaseConnection();
                method = null;
            }
        }
    }

}
